scala.tools.nsc.symtab.classfile

# ICodeReader

###
Related Doc: package classfile

#### abstract class ICodeReader extends ClassfileParser

ICode reader from Java bytecode.

Source
  ICodeReader.scala
Version

  1.0

Linear Supertypes
ClassfileParser, AnyRef, Any
Known Subclasses
icodeReader
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ICodeReader
2. ClassfileParser
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ICodeReader()

### Type Members

1. #### class ConstantPool extends AnyRef

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Attributes
     protected
   Definition Classes
     ClassfileParser

2. #### class ICodeConstantPool extends ConstantPool

   Attributes
     protected

3. #### case class InnerClassEntry(external: Int, outer: Int, name: Int, jflags: JavaAccFlags) extends Product with Serializable

   An entry in the InnerClasses attribute of this class file.

   An entry in the InnerClasses attribute of this class file.

   Definition Classes
     ClassfileParser

4. #### class LazyAliasType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

   Definition Classes
     ClassfileParser

5. #### class LinearCode extends AnyRef

6. #### type ThisConstantPool = ICodeConstantPool

   Attributes
     protected
   Definition Classes
     ICodeReader → ClassfileParser

7. #### class TypeParamsType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

   Definition Classes
     ClassfileParser

### Abstract Value Members

1. #### abstract def classFileLookup: ClassFileLookup[AbstractFile]

   The way of the class file lookup used by the compiler.

   The way of the class file lookup used by the compiler.

   Definition Classes
     ClassfileParser

2. #### abstract val global: Global

3. #### abstract val loaders: Global.loaders

   Definition Classes
     ICodeReader → ClassfileParser

4. #### abstract def lookupMemberAtTyperPhaseIfPossible(sym: Global.Symbol, name: Global.Name): Global.Symbol

   If typer phase is defined then perform member lookup of a symbol `sym` at typer phase.

   If typer phase is defined then perform member lookup of a symbol `sym` at typer phase. This method results from refactoring. The original author of the logic that uses typer phase didn't explain why we need to force infos at that phase specifically. It only mentioned that ClassfileParse can be called late (e.g. at flatten phase) and we make to make sure we handle such situation properly.

   Attributes
     protected
   Definition Classes
     ClassfileParser

5. #### abstract val symbolTable: global.type

   Definition Classes
     ICodeReader → ClassfileParser

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodeReader to any2stringadd[ICodeReader] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodeReader, B)

   Implicit information
     This member is added by an implicit conversion from ICodeReader to ArrowAssoc[ICodeReader] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val JVM: reflect.internal.ClassfileConstants.type

7. #### def addEnclosingTParams(clazz: Global.Symbol): Unit

   Add type parameters of enclosing classes

   Add type parameters of enclosing classes

   Definition Classes
     ClassfileParser

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### var busy: Global.Symbol

   Attributes
     protected
   Definition Classes
     ClassfileParser

10. #### def classNameToSymbol(name: Global.Name): Global.Symbol

    Return the class symbol of the given name.

    Return the class symbol of the given name.

    Definition Classes
      ICodeReader → ClassfileParser

11. #### var classTParams: Map[Global.Name, Global.Symbol]

    Attributes
      protected
    Definition Classes
      ClassfileParser

12. #### var clazz: Global.Symbol

    Attributes
      protected
    Definition Classes
      ClassfileParser

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

14. #### var currentClass: Global.Name

    Attributes
      protected
    Definition Classes
      ClassfileParser

15. #### def ensuring(cond: (ICodeReader) ⇒ Boolean, msg: ⇒ Any): ICodeReader

    Implicit information
      This member is added by an implicit conversion from ICodeReader to Ensuring[ICodeReader] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (ICodeReader) ⇒ Boolean): ICodeReader

    Implicit information
      This member is added by an implicit conversion from ICodeReader to Ensuring[ICodeReader] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodeReader

    Implicit information
      This member is added by an implicit conversion from ICodeReader to Ensuring[ICodeReader] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): ICodeReader

    Implicit information
      This member is added by an implicit conversion from ICodeReader to Ensuring[ICodeReader] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

21. #### var file: AbstractFile

    Attributes
      protected
    Definition Classes
      ClassfileParser

22. #### def forceMangledName(name: Global.Name, module: Boolean): Global.Symbol

    Try to force the chain of enclosing classes for the given name.

    Try to force the chain of enclosing classes for the given name. Otherwise flatten would not lift classes that were not referenced in the source code.

23. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodeReader to StringFormat[ICodeReader] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

24. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

25. #### def getCode(flags: JavaAccFlags): Global.icodes.IClass

    Return the icode class that should include members with the given flags.

    Return the icode class that should include members with the given flags. There are two possible classes, the static part and the instance part.

26. #### def getScope(flags: JavaAccFlags): Global.Scope

    Attributes
      protected
    Definition Classes
      ClassfileParser

27. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

28. #### var in: AbstractFileReader

    Attributes
      protected
    Definition Classes
      ClassfileParser

29. #### object innerClasses

    Return the class symbol for the given name.

    Return the class symbol for the given name. It looks it up in its outer class. Forces all outer class symbols to be completed.

    If the given name is not an inner class, it returns the symbol found in `definitions`.

    Definition Classes
      ClassfileParser

30. #### var instanceCode: Global.icodes.IClass

31. #### var instanceScope: Global.Scope

    Attributes
      protected
    Definition Classes
      ClassfileParser

32. #### def isBox(m: Global.Symbol): Boolean

    Note: these methods are different from the methods of the same name found in Definitions.

    Note: these methods are different from the methods of the same name found in Definitions. These test whether a symbol represents one of the boxTo/unboxTo methods found in BoxesRunTime. The others test whether a symbol represents a synthetic method from one of the fake companion classes of the primitive types, such as Int.box(5).

33. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

34. #### var isScala: Boolean

    Attributes
      protected
    Definition Classes
      ClassfileParser

35. #### var isScalaAnnot: Boolean

    Attributes
      protected
    Definition Classes
      ClassfileParser

36. #### var isScalaModule: Boolean

37. #### var isScalaRaw: Boolean

    Attributes
      protected
    Definition Classes
      ClassfileParser

38. #### def isUnbox(m: Global.Symbol): Boolean

39. #### var maxLocals: Int

40. #### var maxStack: Int

41. #### var method: Global.icodes.IMethod

42. #### def moduleClass: Global.Symbol

    Attributes
      protected
    Definition Classes
      ClassfileParser

43. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

44. #### def newConstantPool: ICodeConstantPool

    Attributes
      protected
    Definition Classes
      ICodeReader → ClassfileParser

45. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

46. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

47. #### def parse(file: AbstractFile, root: Global.Symbol): Unit

    Definition Classes
      ClassfileParser

48. #### def parseAttribute(): Unit

49. #### def parseAttributes(sym: Global.Symbol, symtype: Global.Type): Unit

    Definition Classes
      ClassfileParser

50. #### def parseByteCode(): Unit

    Parse java bytecode into ICode

51. #### def parseClass(): Unit

    Definition Classes
      ICodeReader → ClassfileParser

52. #### def parseField(): Unit

    Definition Classes
      ICodeReader → ClassfileParser

53. #### def parseInnerClasses(): Unit

    Parse inner classes.

    Parse inner classes. Expects `in.bp` to point to the superclass entry. Restores the old `bp`.

    Definition Classes
      ClassfileParser

54. #### def parseMethod(): Unit

    Definition Classes
      ICodeReader → ClassfileParser

55. #### var pc: Int

56. #### var pool: ThisConstantPool

    Attributes
      protected
    Definition Classes
      ClassfileParser

57. #### def readClass(cls: Global.Symbol): (Global.icodes.IClass, Global.icodes.IClass)

    Read back bytecode for the given class symbol.

    Read back bytecode for the given class symbol. It returns two IClass objects, one for static members and one for non-static members.

58. #### final def s1(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

59. #### final def s2(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

60. #### def skipAttributes(): Unit

    Definition Classes
      ClassfileParser

61. #### def skipMembers(): Unit

    Definition Classes
      ClassfileParser

62. #### def skipSuperclasses(): Unit

    Definition Classes
      ClassfileParser

63. #### def srcfile: Option[AbstractFile]

    Definition Classes
      ClassfileParser

64. #### var srcfile0: Option[AbstractFile]

    Attributes
      protected
    Definition Classes
      ClassfileParser

65. #### var staticCode: Global.icodes.IClass

66. #### var staticModule: Global.Symbol

    Attributes
      protected
    Definition Classes
      ClassfileParser

67. #### var staticScope: Global.Scope

    Attributes
      protected
    Definition Classes
      ClassfileParser

68. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

69. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

70. #### def toUnsignedByte(b: Byte): Int

71. #### final def u1(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

72. #### final def u2(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

73. #### final def u4(): Int

    Attributes
      protected
    Definition Classes
      ClassfileParser

74. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

75. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

76. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

77. #### def →[B](y: B): (ICodeReader, B)

    Implicit information
      This member is added by an implicit conversion from ICodeReader to ArrowAssoc[ICodeReader] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from ClassfileParser

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodeReader to any2stringadd[ICodeReader]

### Inherited by implicit conversion StringFormat from ICodeReader to StringFormat[ICodeReader]

### Inherited by implicit conversion Ensuring from ICodeReader to Ensuring[ICodeReader]

### Inherited by implicit conversion ArrowAssoc from ICodeReader to ArrowAssoc[ICodeReader]

### Ungrouped